#include <driver/dac.h>
#include "SoundData.h"  // wav data with header 

// The Canonical WAVE file format
typedef struct {
	uint8_t  ChunkID[4];
	uint32_t ChunkSize;
	uint8_t  Format[4];
	uint8_t  Subchunk1ID[4];
	uint32_t Subchunk1Size;
	uint16_t AudioFormat;
	uint16_t NumChannels;
	uint32_t SampleRate;
	uint32_t ByteRate;
	uint16_t BlockAlign;
	uint16_t BitPerSample;
	uint8_t  Subchunk2ID[4];
	uint32_t Subchunk2Size;
} WAVE_FORMAT;

void play(unsigned char *audio) {
	WAVE_FORMAT *pwf = (WAVE_FORMAT *)audio;
	uint8_t  *p;
	uint16_t cnt;
	uint16_t delayus;

	delayus = 1000000/pwf->SampleRate;
	dac_output_enable(DAC_CHANNEL_1);

	cnt = pwf->Subchunk2Size;
	p = audio + sizeof(WAVE_FORMAT);
	while (cnt > 0) {
		dac_output_voltage(DAC_CHANNEL_1, *p);
		ets_delay_us(delayus);
		p   += pwf->NumChannels;
		cnt -= pwf->NumChannels;
	}
}

void setup() {
	play(pacman);
	delay(2000);
	play(pacmanDeath);
	delay(2000);
	play(chomp);
	delay(2000);
}

void loop() {}
